/*
	This simple extension of the java.awt.Frame class
	contains all the elements necessary to act as the
	main window of an application.
 */

import java.awt.*;
import java.io.*;


import symantec.itools.awt.util.edit.SocialSecurityNumber;
public class EmployeeDataManager extends Frame
{
	final static String employeeFileName = "employee.dat";
	EmployeeFileAccessor efa;

	void updateEmployeeDisplay(EmployeeList elist)
	{
		Employee emp = elist.first();
		String textdata = "";
		for (;;)
		{
			if (emp == null) break;
			System.out.println("Appending " + emp.toString() + " to textarea");
			textdata += emp.toString();
			emp = elist.next();
		}
		ta.setText(textdata);
	}

	public EmployeeDataManager()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.

		//{{INIT_CONTROLS
		setLayout(new BorderLayout(0,0));
		setBackground(java.awt.Color.lightGray);
		setForeground(java.awt.Color.black);
		setFont(new Font("Dialog", Font.PLAIN, 12));
		setSize(751,309);
		setVisible(false);
		addPanel.setLayout(new GridBagLayout());
		add("North", addPanel);
		addPanel.setBounds(0,0,751,23);
		label1.setText("Name:");
		label1.setAlignment(java.awt.Label.RIGHT);
		addPanel.add(label1, new com.symantec.itools.awt.GridBagConstraintsD(0,0,1,1,1.0,1.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		label1.setBounds(39,0,51,23);
		addPanel.add(nfield, new com.symantec.itools.awt.GridBagConstraintsD(1,0,1,1,2.0,1.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		nfield.setBounds(90,0,102,23);
		label2.setText("Section#:");
		label2.setAlignment(java.awt.Label.RIGHT);
		addPanel.add(label2, new com.symantec.itools.awt.GridBagConstraintsD(2,0,1,1,1.0,1.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		label2.setBounds(231,0,65,23);
		addPanel.add(afield, new com.symantec.itools.awt.GridBagConstraintsD(3,0,1,1,1.0,1.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),0,0));
		afield.setBounds(296,0,63,23);
		label3.setText(" SSN:");
		label3.setAlignment(java.awt.Label.RIGHT);
		addPanel.add(label3, new com.symantec.itools.awt.GridBagConstraintsD(4,0,1,1,1.0,1.0,java.awt.GridBagConstraints.EAST,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		label3.setBounds(398,0,45,23);
		sfield.setColumns(30);
		sfield.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.TEXT_CURSOR));
		addPanel.add(sfield, new com.symantec.itools.awt.GridBagConstraintsD(5,0,1,1,2.0,1.0,java.awt.GridBagConstraints.WEST,java.awt.GridBagConstraints.HORIZONTAL,new Insets(0,0,0,0),30,0));
		sfield.setBackground(java.awt.Color.white);
		sfield.setFont(new Font("Dialog", Font.PLAIN, 12));
		sfield.setBounds(443,2,233,19);
		addbutton.setLabel("Add");
		addPanel.add(addbutton, new com.symantec.itools.awt.GridBagConstraintsD(6,0,1,1,1.0,1.0,java.awt.GridBagConstraints.CENTER,java.awt.GridBagConstraints.NONE,new Insets(0,0,0,0),0,0));
		addbutton.setBounds(695,0,35,23);
		sortPanel.setLayout(new GridBagLayout());
		add("Center", sortPanel);
		sortPanel.setBounds(0,23,751,286);
		choice.addItem("Name");
		choice.addItem("Section");
		choice.addItem("SSN");
		try {
			choice.select(0);
		}
		catch (IllegalArgumentException e) { }
		sortPanel.add(choice, new com.symantec.itools.awt.GridBagConstraintsD(0,0,1,1,1.0,1.0,java.awt.GridBagConstraints.NORTH,java.awt.GridBagConstraints.HORIZONTAL,new Insets(30,10,0,0),0,0));
		choice.setBackground(java.awt.Color.white);
		choice.setBounds(10,30,129,25);
		sortbutton.setLabel("Sort");
		sortPanel.add(sortbutton, new com.symantec.itools.awt.GridBagConstraintsD(1,0,1,1,1.0,1.0,java.awt.GridBagConstraints.NORTH,java.awt.GridBagConstraints.NONE,new Insets(30,0,0,0),0,0));
		sortbutton.setFont(new Font("Dialog", Font.PLAIN, 12));
		sortbutton.setBounds(169,30,36,23);
		sortPanel.add(ta, new com.symantec.itools.awt.GridBagConstraintsD(2,0,1,1,1.0,1.0,java.awt.GridBagConstraints.NORTH,java.awt.GridBagConstraints.BOTH,new Insets(30,0,40,15),0,0));
		ta.setBounds(235,30,500,216);
		setTitle("Employee Data Manager");
		//}}

		//{{INIT_MENUS
		menu1.setLabel("File");
		menu1.add(miExit);
		miExit.setLabel("Exit");
		mainMenuBar.add(menu1);
		menu3.setLabel("Help");
		menu3.add(miAbout);
		miAbout.setLabel("About..");
		mainMenuBar.add(menu3);
		mainMenuBar.setHelpMenu(menu3);
		//$$ mainMenuBar.move(4,277);
		setMenuBar(mainMenuBar);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		miAbout.addActionListener(lSymAction);
		miExit.addActionListener(lSymAction);
		addbutton.addActionListener(lSymAction);
		sortbutton.addActionListener(lSymAction);
		//}}

		System.out.println("Opening file");
		try
		{
			efa = new EmployeeFileAccessor(employeeFileName);
			System.out.println("File opened");
		}
		catch (IOException e)
		{
			System.out.println("Unable to open file " + employeeFileName);
			return;
		}

		// Fetch all employees from file, and display them in the text area
		EmployeeList elist = efa.buildEmployeeList();
		updateEmployeeDisplay(elist);

	}

	public EmployeeDataManager(String title)
	{
		this();
		setTitle(title);
	}

	public  void setVisible(boolean b)
	{
		if (b == true) {
		    setLocation(50, 50);
		}
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new EmployeeDataManager()).show();
	}

	public void addNotify()
	{
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + getSize().width, getInsets().top + getInsets().bottom + getSize().height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.Panel addPanel = new java.awt.Panel();
	java.awt.Label label1 = new java.awt.Label();
	java.awt.TextField nfield = new java.awt.TextField();
	java.awt.Label label2 = new java.awt.Label();
	java.awt.TextField afield = new java.awt.TextField();
	java.awt.Label label3 = new java.awt.Label();
	symantec.itools.awt.util.edit.SocialSecurityNumber sfield = new symantec.itools.awt.util.edit.SocialSecurityNumber();
	java.awt.Button addbutton = new java.awt.Button();
	java.awt.Panel sortPanel = new java.awt.Panel();
	java.awt.Choice choice = new java.awt.Choice();
	java.awt.Button sortbutton = new java.awt.Button();
	java.awt.TextArea ta = new java.awt.TextArea(5,0);
	//}}

	//{{DECLARE_MENUS
	java.awt.MenuBar mainMenuBar = new java.awt.MenuBar();
	java.awt.Menu menu1 = new java.awt.Menu();
	java.awt.MenuItem miExit = new java.awt.MenuItem();
	java.awt.Menu menu3 = new java.awt.Menu();
	java.awt.MenuItem miAbout = new java.awt.MenuItem();
	//}}

	private void addEmployee()
	{
	    Employee emp;

		// The ADD button was pressed; add new employee
		System.out.println("Add an employee");

		// Create (and validate) an employee object
		try	{
		    // get the SS Number String and add dashes if needed
		    String ssn = sfield.getText();
		    if (ssn.charAt(3) != '-')
		    {
		        ssn = ssn.substring(0,3) + '-' + ssn.substring(3);
		    }
		    if (ssn.charAt(6) != '-')
		    {
		        ssn = ssn.substring(0,6) + '-' + ssn.substring(6);	        
		    }		    
		    
			emp = new Employee (nfield.getText(), afield.getText(), ssn);
		} catch (Exception ex1)	{
			System.out.println("Invalid employee data");
			System.out.println(ex1.getMessage());
			//showStatus("Invalid employee data; please re-enter");
			return;
		}

		// Add the employee to the file
		try
		{
			efa.addEmployee(emp);
		}
		catch (IOException ex2)
		{
			System.out.println("Unable to add employee to file");
			return;
		}

		System.out.println("Employee added");

		// Redisplay the employee data
		EmployeeList elist = efa.buildEmployeeList();
		updateEmployeeDisplay(elist);
	}

	private void sortEmployees()
	{
    	// The SORT button was pressed; perform sort
    	EmployeeList elist = efa.buildEmployeeList();
    	elist.sort(choice.getSelectedIndex());
    	System.out.println("Sort on field " + choice.getSelectedIndex());

    	// Redisplay the employee data
    	updateEmployeeDisplay(elist); 
	}

	public void cleanupAndClose()
	{
		this.setVisible(false);
		this.dispose();
		System.exit(0); // close the application
	}
	
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == EmployeeDataManager.this)
				EmployeeDataManager_WindowClosing(event);
		}
	}

	void EmployeeDataManager_WindowClosing(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
			 
		EmployeeDataManager_WindowClosing_Interaction1(event);
	}

	void EmployeeDataManager_WindowClosing_Interaction1(java.awt.event.WindowEvent event)
	{
		try {
			cleanupAndClose();
		} catch (Exception e) {
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == miAbout)
				miAbout_ActionPerformed(event);
			else if (object == miExit)
				miExit_ActionPerformed(event);
			else if (object == addbutton)
				addbutton_ActionPerformed(event);
			else if (object == sortbutton)
				sortbutton_ActionPerformed(event);
		}
	}

	void miAbout_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		miAbout_ActionPerformed_Interaction1(event);
	}

	void miAbout_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// AboutDialog Create and show as modal
			(new AboutDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	void miExit_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		miExit_ActionPerformed_Interaction1(event);
	}

	void miExit_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			// QuitDialog Create and show as modal
			(new QuitDialog(this, true)).setVisible(true);
		} catch (Exception e) {
		}
	}

	void addbutton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		addbutton_ActionPerformed_Interaction1(event);
	}

	void addbutton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.addEmployee();
		} catch (Exception e) {
		}
	}

	void sortbutton_ActionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
			 
		sortbutton_ActionPerformed_Interaction1(event);
	}

	void sortbutton_ActionPerformed_Interaction1(java.awt.event.ActionEvent event)
	{
		try {
			this.sortEmployees();
		} catch (Exception e) {
		}
	}
}

